<html>
<head>
  <title>./2_interface_property_list/main.c</title>
</head>
<body bgcolor="#ffffff" text="#000000">
<pre>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-eth-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-interface-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-modem-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-network-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-wifi-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;pthread.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;signal.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdio.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdlib.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;string.h&gt;</font></strong></font>

<strong>void</strong> <font color="#2040a0">usage</font><font color="4444FF">(</font><strong>void</strong><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;USAGE: list_property [Interface Name] or list_property [Interface Name] [Property Nmae]<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">show_all_property</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong> <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <strong>int</strong> <font color="#2040a0">num</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>

    <font color="#2040a0">mcm_network_info</font>   <font color="#2040a0">network_info</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_property_info</font> <font color="4444FF">*</font><font color="#2040a0">info_arr</font><font color="4444FF">;</font>

    <font color="#2040a0">memset</font><font color="4444FF">(</font><font color="4444FF">&amp;</font><font color="#2040a0">network_info</font>, <font color="#FF0000">0</font>, <strong>sizeof</strong><font color="4444FF">(</font><font color="#2040a0">mcm_network_info</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_get_network_info</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">network_info</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get interface (%s) information failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">network_info</font>.<font color="#2040a0">device_type</font>, <font color="#008000">&quot;Ethernet&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;Ethernet&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_ethernet_get_all_properties</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">num</font>, <font color="4444FF">&amp;</font><font color="#2040a0">info_arr</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">network_info</font>.<font color="#2040a0">device_type</font>, <font color="#008000">&quot;WiFi&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;WiFi&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_wifi_get_all_properties</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">num</font>, <font color="4444FF">&amp;</font><font color="#2040a0">info_arr</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">network_info</font>.<font color="#2040a0">device_type</font>, <font color="#008000">&quot;Modem&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;Modem&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_modem_get_all_properties</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">num</font>, <font color="4444FF">&amp;</font><font color="#2040a0">info_arr</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get interface (%s) property list failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Property List:<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>for</strong> <font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">i</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font> <font color="#2040a0">i</font> <font color="4444FF">&lt;</font> <font color="#2040a0">num</font><font color="4444FF">;</font> <font color="#2040a0">i</font><font color="4444FF">+</font><font color="4444FF">+</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;<font color="#77dd77">\t</font>%s = %s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">info_arr</font><font color="4444FF">[</font><font color="#2040a0">i</font><font color="4444FF">]</font>.<font color="#2040a0">propertyName</font>, <font color="#2040a0">info_arr</font><font color="4444FF">[</font><font color="#2040a0">i</font><font color="4444FF">]</font>.<font color="#2040a0">propertyValue</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>
    <font color="#2040a0">mcm_free_property_info</font><font color="4444FF">(</font><font color="#2040a0">num</font>, <font color="#2040a0">info_arr</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">get_property</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font>, <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">property_name</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong>   <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">device_type</font><font color="4444FF">;</font>
    <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">property_val</font><font color="4444FF">;</font>

    <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_network_get_property</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="#008000">&quot;DeviceType&quot;</font>, <font color="4444FF">&amp;</font><font color="#2040a0">device_type</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get interface (%s) DeviceType failed:(%d)%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font>, <font color="#2040a0">mcm_get_error_message</font><font color="4444FF">(</font><font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="#2040a0">ret</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_network_get_property</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="#2040a0">property_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">property_val</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;%s:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">property_name</font>, <font color="#2040a0">property_val</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">device_type</font>, <font color="#008000">&quot;Ethernet&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;Ethernet&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_ethernet_get_property</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="#2040a0">property_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">property_val</font>, <font color="#2040a0">false</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">device_type</font>, <font color="#008000">&quot;WiFi&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;WiFi&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_wifi_get_property</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="#2040a0">property_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">property_val</font>, <font color="#2040a0">false</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">device_type</font>, <font color="#008000">&quot;Modem&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;Modem&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_modem_get_property</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="#2040a0">property_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">property_val</font>, <font color="#2040a0">false</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get interface (%s) property (%s) failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">property_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;%s:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">property_name</font>, <font color="#2040a0">property_val</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">main</font><font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">argc</font>, <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="4444FF">]</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>

    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#FF0000">2</font><font color="4444FF">)</font>
        <strong>return</strong> <font color="#2040a0">show_all_property</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#FF0000">3</font><font color="4444FF">)</font>
        <strong>return</strong> <font color="#2040a0">get_property</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font>, <font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">2</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">usage</font><font color="4444FF">(</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>
<font color="4444FF"><strong>}</strong></font>

</pre>
<hr>
syntax highlighted by <a href="http://www.palfrader.org/code2html">Code2HTML</a>, v. 0.9.1
</body>
</html>
